Show / Hide Table of Contents

# Class DataManager

This class provides data for Dalamud-internal features, but can also be used by plugins if needed.

##### Inheritance

System.Object
DataManager

##### Implements

System.IDisposable

##### Inherited Members

System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)
System.Object.ToString()

###### Namespace: Dalamud.Data

###### Assembly: Dalamud.dll

##### Syntax

    public sealed class DataManager : IDisposable

### Properties

| Improve this Doc View Source

#### ClientOpCodes

Gets the OpCodes sent by the client to the server.

##### Declaration

    [UsedImplicitly]
    public ReadOnlyDictionary<string, ushort> ClientOpCodes { get; }

##### Property Value

Type | Description
--- | ---
System.Collections.ObjectModel.ReadOnlyDictionary<System.String, System.UInt16> |

| Improve this Doc View Source

#### Excel

Gets an Lumina.Excel.ExcelModule object which gives access to any of the game's sheet data.

##### Declaration

    public ExcelModule Excel { get; }

##### Property Value

Type | Description
--- | ---
Lumina.Excel.ExcelModule |

| Improve this Doc View Source

#### GameData

Gets a Lumina object which gives access to any excel/game data.

##### Declaration

    public GameData GameData { get; }

##### Property Value

Type | Description
--- | ---
Lumina.GameData |

| Improve this Doc View Source

#### IsDataReady

Gets a value indicating whether Game Data is ready to be read.

##### Declaration

    public bool IsDataReady { get; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Language

Gets the current game client language.

##### Declaration

    public ClientLanguage Language { get; }

##### Property Value

Type | Description
--- | ---
ClientLanguage |

| Improve this Doc View Source

#### ServerOpCodes

Gets the OpCodes sent by the server to the client.

##### Declaration

    public ReadOnlyDictionary<string, ushort> ServerOpCodes { get; }

##### Property Value

Type | Description
--- | ---
System.Collections.ObjectModel.ReadOnlyDictionary<System.String, System.UInt16> |

### Methods

| Improve this Doc View Source

#### Dispose()

Dispose this DataManager.

##### Declaration

    public void Dispose()

| Improve this Doc View Source

#### FileExists(String)

Check if the file with the given path exists within the game's index files.

##### Declaration

    public bool FileExists(string path)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | path | The path inside of the game files.

##### Returns

Type | Description
--- | ---
System.Boolean | True if the file exists.

| Improve this Doc View Source

#### GetExcelSheet<T>()

Get an Lumina.Excel.ExcelSheet<T> with the given Excel sheet row type.

##### Declaration

    public ExcelSheet<T> GetExcelSheet<T>()
        where T : ExcelRow

##### Returns

Type | Description
--- | ---
Lumina.Excel.ExcelSheet<T> | The Lumina.Excel.ExcelSheet<T>, giving access to game rows.

##### Type Parameters

Name | Description
--- | ---
T | The excel sheet type to get.

| Improve this Doc View Source

#### GetExcelSheet<T>(ClientLanguage)

Get an Lumina.Excel.ExcelSheet<T> with the given Excel sheet row type with a specified language.

##### Declaration

    public ExcelSheet<T> GetExcelSheet<T>(ClientLanguage language)
        where T : ExcelRow

##### Parameters

Type | Name | Description
--- | --- | ---
ClientLanguage | language | Language of the sheet to get.

##### Returns

Type | Description
--- | ---
Lumina.Excel.ExcelSheet<T> | The Lumina.Excel.ExcelSheet<T>, giving access to game rows.

##### Type Parameters

Name | Description
--- | ---
T | The excel sheet type to get.

| Improve this Doc View Source

#### GetFile(String)

Get a Lumina.Data.FileResource with the given path.

##### Declaration

    public FileResource GetFile(string path)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | path | The path inside of the game files.

##### Returns

Type | Description
--- | ---
Lumina.Data.FileResource | The Lumina.Data.FileResource of the file.

| Improve this Doc View Source

#### GetFile<T>(String)

Get a Lumina.Data.FileResource with the given path, of the given type.

##### Declaration

    public T GetFile<T>(string path)
        where T : FileResource

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | path | The path inside of the game files.

##### Returns

Type | Description
--- | ---
T | The Lumina.Data.FileResource of the file.

##### Type Parameters

Name | Description
--- | ---
T | The type of resource.

| Improve this Doc View Source

#### GetHqIcon(UInt32)

Get a Lumina.Data.Files.TexFile containing the HQ icon with the given ID.

##### Declaration

    public TexFile GetHqIcon(uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
Lumina.Data.Files.TexFile | The Lumina.Data.Files.TexFile containing the icon.

| Improve this Doc View Source

#### GetIcon(ClientLanguage, UInt32)

Get a Lumina.Data.Files.TexFile containing the icon with the given ID, of the given language.

##### Declaration

    public TexFile GetIcon(ClientLanguage iconLanguage, uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
ClientLanguage | iconLanguage | The requested language.
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
Lumina.Data.Files.TexFile | The Lumina.Data.Files.TexFile containing the icon.

| Improve this Doc View Source

#### GetIcon(Boolean, UInt32)

Get a Lumina.Data.Files.TexFile containing the icon with the given ID, of the given quality.

##### Declaration

    public TexFile GetIcon(bool isHq, uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Boolean | isHq | A value indicating whether the icon should be HQ.
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
Lumina.Data.Files.TexFile | The Lumina.Data.Files.TexFile containing the icon.

| Improve this Doc View Source

#### GetIcon(String, UInt32)

Get a Lumina.Data.Files.TexFile containing the icon with the given ID, of the given type.

##### Declaration

    public TexFile GetIcon(string type, uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | type | The type of the icon (e.g. 'hq' to get the HQ variant of an item icon).
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
Lumina.Data.Files.TexFile | The Lumina.Data.Files.TexFile containing the icon.

| Improve this Doc View Source

#### GetIcon(UInt32)

Get a Lumina.Data.Files.TexFile containing the icon with the given ID.

##### Declaration

    public TexFile GetIcon(uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
Lumina.Data.Files.TexFile | The Lumina.Data.Files.TexFile containing the icon.

| Improve this Doc View Source

#### GetImGuiTexture(TexFile)

Get the passed Lumina.Data.Files.TexFile as a drawable ImGui TextureWrap.

##### Declaration

    public TextureWrap GetImGuiTexture(TexFile tex)

##### Parameters

Type | Name | Description
--- | --- | ---
Lumina.Data.Files.TexFile | tex | The Lumina Lumina.Data.Files.TexFile.

##### Returns

Type | Description
--- | ---
TextureWrap | A TextureWrap that can be used to draw the texture.

| Improve this Doc View Source

#### GetImGuiTexture(String)

Get the passed texture path as a drawable ImGui TextureWrap.

##### Declaration

    public TextureWrap GetImGuiTexture(string path)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | path | The internal path to the texture.

##### Returns

Type | Description
--- | ---
TextureWrap | A TextureWrap that can be used to draw the texture.

| Improve this Doc View Source

#### GetImGuiTextureHqIcon(UInt32)

Get a TextureWrap containing the HQ icon with the given ID.

##### Declaration

    public TextureWrap GetImGuiTextureHqIcon(uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
TextureWrap | The TextureWrap containing the icon.

| Improve this Doc View Source

#### GetImGuiTextureIcon(ClientLanguage, UInt32)

Get a TextureWrap containing the icon with the given ID, of the given language.

##### Declaration

    public TextureWrap GetImGuiTextureIcon(ClientLanguage iconLanguage, uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
ClientLanguage | iconLanguage | The requested language.
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
TextureWrap | The TextureWrap containing the icon.

| Improve this Doc View Source

#### GetImGuiTextureIcon(Boolean, UInt32)

Get a TextureWrap containing the icon with the given ID, of the given quality.

##### Declaration

    public TextureWrap GetImGuiTextureIcon(bool isHq, uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Boolean | isHq | A value indicating whether the icon should be HQ.
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
TextureWrap | The TextureWrap containing the icon.

| Improve this Doc View Source

#### GetImGuiTextureIcon(String, UInt32)

Get a TextureWrap containing the icon with the given ID, of the given type.

##### Declaration

    public TextureWrap GetImGuiTextureIcon(string type, uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | type | The type of the icon (e.g. 'hq' to get the HQ variant of an item icon).
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
TextureWrap | The TextureWrap containing the icon.

| Improve this Doc View Source

#### GetImGuiTextureIcon(UInt32)

Get a TextureWrap containing the icon with the given ID.

##### Declaration

    public TextureWrap GetImGuiTextureIcon(uint iconId)

##### Parameters

Type | Name | Description
--- | --- | ---
System.UInt32 | iconId | The icon ID.

##### Returns

Type | Description
--- | ---
TextureWrap | The TextureWrap containing the icon.

### Implements

System.IDisposable